#! /usr/bin/perl
#
#  lpim - List Printer Account Improved
#
require "lp_inc";

sub usage {
	#output for user
	print "usage $0 user pages -|c|b [printer]\n";
        print "+\tpay\n-\tprint\nc\tcorrection\nb\tburden\n";
}
readconf();
# check number of parameters
if (($#ARGV <2) || ($#ARGV>3) ) {
	usage;
	exit
}
$user=$ARGV[0];
$pages=$ARGV[1];
$flag=$ARGV[2];
$printer=$ARGV[3];
#---
# does user exist ?
($uname,$nix)=getpwnam($user);
if (!$uname) {
	printf("No such user '$user'\n");
	exit;
}
#---
# check page number
if ( ($pages < 0) || ($pages>5000) ) {
	print "number of page not allowed\n";
	exit
}
#---
#check for flag
if ( $flag !~ /[\-|c|b]/ ) {
	print "Error: unknown command: $flag\n";
	usage;
	exit;
}
#---
#parse current time
($s,$m,$h,$d,$mn,$y,$nix,$nix,$nix)=gmtime(time);
$mn++; #special format of unix time struct
$y+=1900; #special format of unix time struct
$dat= sprintf ("%04s%02s%02s%02s%02s%02s", $y, $mn, $d, $h, $m, $s);
#---
if ($flag =~ /[\-]/) { #if flag is i, for information program mode
	#check for freegroup
	if (check_free($user)) {
		$free=$pages;
	}
	#---
	# check for freeperiod
	$free_limit=readcontingent($user);
	#---
	$s="";
	if ($free>0) {
		$s = sprintf ("%s:%s:%d:%s:%s\n", $dat, $user, $pages, "f",$printer);
	} else {
		#printf("kein freies drucken pages=%d fl=%d\n",$pages,$free_limit);
		if ($pages>=$free_limit) {
			if ($free_limit>0) {
				$s = sprintf ("%s:%s:%d:%s:%s\n", $dat, $user, $free_limit, "F", $printer);
			}
			if ( $pages-$free_limit>0) { #if print job is just at border of free und not free resources
				$s .= sprintf ("%s:%s:%d:%s:%s\n", $dat, $user, $pages-$free_limit, "-",$printer);
			}
		} else {
			$s = sprintf ("%s:%s:%d:%s:%s\n", $dat, $user, $pages, "F",$printer);
		}
	}
	#---
} else {
	#none printing mode
	$s = sprintf ("%s:%s:%d:%s:%s\n", $dat, $user, $pages, $flag,$printer);
}
#does file exists?
touch_user_file($user);
#---
#add entry for user
open HAND, ">>$accdir/$user.acc";
print HAND $s;
close HAND;
#---
