#include <curses.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pwd.h>

#define allow "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ+-._0123456789"

int lan;
WINDOW *winc;
int getlan(void) {
	char s[20];
	strcpy(s,getenv("LANG"));
	if (strstr(s,"de")) {
		lan=1;
	}
	return 0;
}
int editstr(char *str, int x, int y) {
	int c;
	mvprintw(x,y,"%s ",str);
	while (c!=27) {
		mvprintw(x,y,"%s_",str);
		mvprintw(x,y,"%s",str);
		c=getch();
		switch (c) {
		case 330:
			break;
		case 263:
			if (strlen(str))
				str[strlen(str)-1]=0;
			break;
		case 27:
			break;
		default:
			if ( strstr( allow , (char*) &c)!=NULL) {
				strcat(str,(char *) &c);
				break;
			}
			return c;
		}
	}
	return c;
}
int startcmd(char *cmd) {
	FILE *f; int i=7; char s[200];
	clear();
	f=popen(cmd,"r");
	while (!feof(f)) {
		if (i>20)
			break;
		if (!fgets(s,4096,f))
			break;
		mvprintw(i++,1,"%s",s);
	}
	fclose(f);
	return 0;
}
int listdown(char *text, int count) {
	int i;
	char *s; char *p;
	s=strdup(text);
	i=7;
	clear();
	//mvprintw(20,20,"%s %d",text,count);
	p=strtok(s," ");
	do {
		if (i>20) {
			mvprintw(i++,1,"...");
			break;
		}
		mvprintw(i++,1,"%s",p);
	} while ((p=strtok(NULL," "))!=NULL);
	free(s);
	return 0;
}
int findmatch(char *match, char *found) {
	struct passwd *p_d;
	int count=0;
	found[0]=0;
	while ( (p_d=getpwent()) !=NULL )  {
		if (!strncmp(match,p_d->pw_name,strlen(match))) {
			count++;
			if (strlen(found)) {
				strcat(found," ");
			}
			strcat(found,p_d->pw_name);
		}
	}
	mvprintw(10,10,found);
	endpwent();
	return count;

}
int main(int argc, char **argv) {
	int c;
	char u[20]; float val;
	char user[50];
	char s[255];
	getlan();
	initscr();
	ESCDELAY=1;
	noecho();
	cbreak();
	keypad(stdscr, TRUE);
	c=0;
	user[0]=0;
	while (c!=27) {
		mvprintw(0,0, "Exit                  (Esc)");
		mvprintw(1,0, "Benutzer ({a..z}/Tab/Enter)   ________","user");
		mvprintw(2,0, "Pay                     ($)   _____");
		mvprintw(3,0, "Repay                   (&)   _____");
		mvprintw(4,0, "Relieve                 (/)   ___");
		mvprintw(5,0, "Burden                  (\\)   ___");
		c=editstr(user,1,30);
		c=(char) c;
		switch (c) {
		case '$': //265: //F1
			if (!user[0]) break;
			u[0]=0;
			editstr(u,2,30);
			val=atof(u);
			sprintf(s,"lp_pay %s %.2f >/dev/null",user,atof(u));
			startcmd(s);
			sprintf(s,"lp_stat %s",user);
			startcmd(s);
			break;
		case '&'://266: //F2
			if (!user[0]) break;
			u[0]=0;
			editstr(u,3,30);
			sprintf(s,"lp_repay %s %.2f",user,atof(u));
			startcmd(s);
			sprintf(s,"lp_stat %s",user);
			startcmd(s);
			break;
		case '/'://271:
			if (!user[0]) break;
			strcpy(u,"");
			editstr(u,4,30);
			sprintf(s,"lp_acc %s %d c",user,atoi(u));
			system(s);
			sprintf(s,"lp_stat %s",user);
			startcmd(s);
			break;
		case '\\': //\:
			if (!user[0]) break;
			strcpy(u,"");
			editstr(u,5,30);
			sprintf(s,"lp_acc %s %d b",user,atoi(u));
			system(s);
			sprintf(s,"lp_stat %s",user);
			startcmd(s);
			break;
		case 27:
			break;
		case 9:
			c=findmatch(user,s);
			listdown(s,c);
			if (c==1) {
				strcpy(user,s);
				sprintf(s,"lp_stat %s",user);
				startcmd(s);
			}
			break;
		case 10:
			sprintf(s,"lp_stat %s",user);
			startcmd(s);
			break;
		}
	}
	endwin();
	return 0;
}
