#! /usr/bin/perl
#
# lpim - List Printer Account Improved
#
require "lp_inc";

sub usage {
	#output for use in case of wronge usage
	print "usage: $0 user\n";
}

readconf();

#check cmd parameters
if ( $#ARGV != 0 ) {
	usage;
	exit;
}
$user=$ARGV[0];
#---
# does user exist ?
($uname,$nix)=getpwnam($user);
#---
#is user in $freegroup?
@groups = split /,/ , $freegroup;
$is_free=0;
for ($i=0;$i<=$#groups;$i++) {
	if ($u =~ /\($groups[$i]\)/) {
		$is_free++;
	}
}
#---
# check for freeuser
if ( "$freeuser," =~ /$user,/ ) {
	$is_free++;
}
#---
# check for account file
if ( !$uname ) {
	#user does not exists
	$label="no";
} else {
	#user exists
	if ( (! -e "$accdir/$user.acc") || $is_free ) {
		#for the case user is in freegroup
		$label="yes";
	} else {
		# statistic output
		$label=get_status($user);
	}
}
#---
#check in deny list
if (check_deny($user)) {
	$label="no";
}
#---
#output
print "$label\n";
#---