#! /usr/bin/perl
#
# lpim - List Printer Account Improved
#
require "lp_inc";

readconf();
sub getprinternumber {
	#get the number of printer in printerlist
	#return value 0,...,numerofspools
	#usage: getprinternumber("lp1");
	for ($x=0;$x<$#printerlist;$x++) {
		if ($printerlist[$x] eq $_[0]) {
			return $x;
		}
	}
	return 0;
}
#defaults for time boundaries
($q,$q,$q,$start_d,$start_mn,$start_y,$q,$q,$q)=gmtime(time()-($period * 24 * 60 * 60));
$start_mn++;
$start_y+=1900;
$dat_last = sprintf "%04d%02d%02d235959", $start_y, $start_mn, $start_d;

($q,$q,$q,$end_d,$end_mn,$end_y,$q,$q,$q)=gmtime(time());
$end_mn++;
$end_y+=1900;

($q,$q,$q,$now_d,$now_mn,$now_y,$q,$q,$q)=gmtime(time());
$now_mn++;
$now_y+=1900;
$dat = sprintf "%04d%02d%02d235959", $now_y, $now_mn, $now_d;
#---
#other parameter
$logflag=0;
$inform=0;
#---
#pars argv
for ($i=0; $i<=$#ARGV; $i++) {
	if ($ARGV[$i] =~ /\-s/) {
		#start time
		if ($ARGV[$i+1] =~ /\./) {
			($start_d,$start_mn,$start_y)=split /\./, $ARGV[$i+1];
		}
		if ($ARGV[$i+1] =~ /\//) {
			($start_d,$start_mn,$start_y)=split /\//, $ARGV[$i+1];
		}
		if ($ARGV[$i+1] =~ /\-/) {
			($start_y,$start_mn,$start_d)=split /\-/, $ARGV[$i+1];
		}
		$i++;
		next;
	}
	if ($ARGV[$i] =~ /\-e/) {
		#end time
		if ($ARGV[$i+1] =~ /\./) {
			($end_d,$end_mn,$end_y)=split /\./, $ARGV[$i+1];
		}
		if ($ARGV[$i+1] =~ /\//) {
			($end_d,$end_mn,$end_y)=split /\//, $ARGV[$i+1];
		}
		if ($ARGV[$i+1] =~ /\-/) {
			($end_y,$end_mn,$end_d)=split /\-/, $ARGV[$i+1];
		}
		$i++;
		next;
	}
	if ($ARGV[$i] =~ /\-log/) {
		#parameter for log printer counter
		$logflag=1;
	}
	if ($ARGV[$i] =~ /\-mail/) {
		$inform=1;
		next;
	}
}
#---
#convert to time string
$time0 = sprintf "%04d%02d%02d000000", $start_y, $start_mn, $start_d;
$time1 = sprintf "%04d%02d%02d235959", $end_y, $end_mn, $end_d;
#---
#first time point in case of -log
if (($logflag) && (-e "$accdir/pagecount")) {
	open H, "$accdir/pagecount";
	while ($l=<H>) {
		$l =~ s/\n//;
		$k=$l;
	}
	close H;
	($nix,$time0,$nix)=split(/:/,$k);
	$start_d=substr($time0,6,2);
	$start_y=substr($time0,0,4);
	$start_mn=substr($time0,4,2);
}
#---

#calculate account
@printed=();
@turned=();
@gained=();
@free=();
@errors=();
@corrections=();
#---
#look for account files, write entries to dirlist
opendir dirh,$accdir;
@dirlist=readdir dirh;
closedir dirh;
#---
#start calculation for each entry of dirlist
for ($i=0;$i<=$#dirlist;$i++) {
	if ( ($dirlist[$i] !~ /.acc/) && ($dirlist[$i] !~ /.ecc/)) {
		#check for none account files and goto next
		next;
	}
	open HAND, "$accdir/$dirlist[$i]";
	while ($u=<HAND>) {
		$u =~ s/\n//g;
		($datum,$user,$page,$flag,$pri,$trans)= split( /:/, $u,6);
		# printed pages
		if ( ($datum<$time0) || ($datum>$time1) ) {
			#skip if date is older than $dat
			next;
		}
		$prinum=getprinternumber($pri);
		#printf("%s prindted=%d\n",$user,$printed[$prinum]);
		if ( $flag =~ /[+]/ ) {
			#pay money to account
			$turned[$prinum]+=$trans;
			$gained[$prinum]+=$trans;
		}
		if ( $flag =~ /[\-]/ ) {
			#print page
			$printed[$prinum]+=$page;
		}
		if ( $flag =~ /[c]/ ) {
			#make correction
			$gained[$prinum]-=get_val($pri)*$page;
			$free[$prinum]+=$page;
			$corrections[$prinum]+=$page;
		}
		if ( $flag =~ /[r]/ ) {
			#pay money to user
			$turned[$prinum]-=$trans;
			$gained[$prinum]-=$trans;
		}
		if ( $flag =~ /[f|F]/ ) {
			#free printed page
			$printed[$prinum]+=$page;
			$free[$prinum]+=$page;
			if ($page == 0) {
				$errors[$prinum]++;
			}
		}
		#printf("%s prindted=%d\n",$user,$printed[$prinum]);
	}
	close HAND;
}
#---
# no negativ gain is valid
if ($gained<0) {
	$gained=0;
}
#---
#show member of free groups
#$free_users=print_list($freeuser,$freegroup);
#$deny_users=print_list($denyuser,$denygroup);
#---
#delete all multiple identy entries
#@aq=sort (split( / /, $free_users));
#for ($i=0;$i<$#aq-1;$i++) {
#	if ( ",$aq[$i]," =~ /,$aq[$i+1],/) {
#	$aq[$i]="";
#	}
#}
#$free_users=join(",",@aq);
#$free_users =~ s/,,/,/g;
#---
#---
#statistic output
@lp_gain_tem=();
$i=0;
open H, "$accdir/lp_gain.tem";
while ($l=<H>) {
	if ($l =~ /\[printer\]/) {
		$i=1;
		next;
	}
	if ($l =~ /\[printer_end\]/) {
		$i=2;
		next;
	}
	$lp_gain_tem[$i].=$l;
}
close H;

$out="";
#pre-printer
$o= sprintf("%2d.%2d. %4d - %2d.%2d. %4d\n",$start_d, $start_mn, $start_y,$end_d, $end_mn, $end_y);
$tem=$lp_gain_tem[0];
$tem=~ s/\$timeperiod/$o/g;
$out .= $tem;
#---------------
#printerlist
for ($prinum=0;$prinum<=$#printerlist;$prinum++) {
	#page counter
	open HAND, "$pagecount_cmd[$prinum]|";
	$newcount=<HAND>;
	$newcount =~ s/\n//;
	close HAND;
	if (length($newcount)==0) {
		$newcount=-1;
	}
	$new_count[$prinum]=$newcount;
	$old_count[$prinum]=-1;
	if (-e "$accdir/pagecount" ) {
		open HAND, "$accdir/pagecount";
		while($s=<HAND>) {
			$s =~ s/\n//;
			($prin_,$dat_,$old_) = split( /:/, $s,3);
			if ($prin_ eq $printerlist[$prinum]) {
				$old_count[$prinum]=$old_;
			}
		}
		close HAND;
	}
	#make log of printer counter
	if (($logflag) ) {
		if (! -e "$accdir/pagecount" ) {
			#make correct permission of log file
			umask "007";
			system "touch $accdir/pagecount";
			system "chgrp $lpgroup $accdir/pagecount";
		}
		open IDS, ">>$accdir/pagecount";
		print IDS "$printerlist[$prinum]:$dat:$new_count[$prinum]\n";
		close IDS;
	}
	#---
	#---------------
	$tem=$lp_gain_tem[1];
	$tem=~ s/\$spoolname/$printerlist[$prinum]/g;
	$o=sprintf("%d",$old_count[$prinum]);
	$tem=~ s/\$oldcount/$o/g;
	$o=sprintf("%d",$new_count[$prinum]);
	$tem=~ s/\$currentcount/$o/g;
	if (($old_count[$prinum]!=-1) && ($new_count[$prinum]!=-1)) {
		$o=sprintf("%d",$new_count[$prinum]-$old_count[$prinum]);
	} else {
		$o="-1";
	}
	$tem=~ s/\$realprinted/$o/g;
	$o=sprintf("%d",$printed[$prinum]);
	$tem=~ s/\$printed/$o/g;
	$o=sprintf("%d",$free[$prinum]);
	$tem=~ s/\$freeprinted/$o/g;
	$o=sprintf("%d",$errors[$prinum]);
	$tem=~ s/\$errors/$o/g;
	$o=sprintf("%d",$corrections[$prinum]);
	$tem=~ s/\$corrections/$o/g;
	$o=sprintf("%.2f",$turned[$prinum]);
	$tem=~ s/\$turnedmoney/$o/g;
	$o=sprintf("%.2f",$gained[$prinum]);
	$tem=~ s/\$gainedmoney/$o/g;
	$out .= $tem;
}
#-------------
$all_turned=0;
$all_gained=0;
for ($x=0;$x<=$#printerlist;$x++) {
	$all_turned+=$turned[$x];
	$all_gained+=$gained[$x];
}

#post-printer
$tem=$lp_gain_tem[2];
$o=sprintf("%.2f",$all_turned);
$tem=~ s/\$totalturnedmoney/$o/g;
$o=sprintf("%.2f",$all_gained);
$tem=~ s/\$totalgainedmoney/$o/g;
$out .= $tem;

#---
#send output as mail
if ($inform) {
	#
	$mailtext .= sprintf ("From: %s\n%s\n",$lpadminmail,$out);
	open IDS, "|/usr/sbin/sendmail \"$lpadminmail\"";
	print IDS $mailtext;
	close IDS;
} else {
	printf("%s",$out);
}
