$configfile="";
sub readconf {
	#readconfig file
	$printer_nr=-1;
	@printerlist=();
	@val=();
	$i=0;
	$freeuser="";
	$freegroup="";
	$denyuser="";
	$denygroup="";
	open HAND, $configfile;
	while ($l = <HAND> ) {
		$l =~ s/#.*//;
		$l =~ s/\n//;
		$p=index($l," ");
		$v=substr($l,$p+1);
		#more line parameter ---
		if ($l =~ /^\[free\]/) {
			$i=1;
			next;
		}
		if ($l =~ /^\[free_end\]/) {
			$i=0;
			next;
		}
		if ($l =~ /^\[deny\]/) {
			$i=2;
			next;
		}
		if ($l =~ /^\[deny_end\]/) {
			$i=0;
			next;
		}
		if ($l =~ /^\[printer\]/) {
			$i=3;
			next;
		}
		if ($l =~ /^\[printer_end\]/) {
			$i=0;
			next;
		}
		#
		if ($i==1) {
			$l =~ s/ //g;
			if ($l =~ /%/) {
				$l =~ s/%//;
				$freegroup .= ",$l";
			} else {
				$freeuser .= ",$l";
			}
		}
		if ($i==2) {
			$l =~ s/ //g;
			if ($l =~ /%/) {
				$l =~ s/%//;
				$denygroup .= ",$l";
			} else {
				$denyuser .= ",$l";
			}
		}
		if ($i==3) {
			if ($l =~ /^spool /) {
				$printer_nr++;
				$printerlist[$printer_nr]=$v;
			}
			if ($l =~ /^val /) {
				$val[$printer_nr]=$v;
			}
			if ($l =~ /^pagecountcmd /) {
				$pagecount_cmd[$printer_nr]=$v;
			}
		}
		#single line parameter ---
		if ($l =~ /^debtlimit /) {
			$debtlimit=$v;
		}
		if ($l =~ /^greylimit /) {
			$greylimit=$v;
		}
		if ($l =~ /^accdir /) {
			   $accdir=$v;
		}
		if ($l =~ /^period /) {
			$period=$v;
		}
		if ($l =~ /^lpadminmail /) {
			$lpadminmail=$v;
		}
		$l =~ s/\n//;
		if ($l =~ /^pagecountcmd /) {
			$pagecountcmd=$v;
		}
		if ($l =~ /^lpgroup /) {
			$lpgroup=$v;
		}
		if ($l =~ /^currency /) {
			$currency=$v;
		}
		if ($l =~ /^queueresetcmd /) {
			$queueresetcmd=$v;
		}
	}
	close HAND;
	return 0;
}
sub check_list {
	#check whether user is in userlist or member of element of groupliste
	#printlist(user, userlist, grouplist);
	#return values 1=is associated, 0=not associated
	$st_=0;
	@g = split /,/ , $_[2];
	for ($i=0;$i<=$#g;$i++) {
		($nix,$nix,$nix,$mem)=getgrnam($g[$i]);
		if (" $mem " =~ / $_[0] /) {
			$st_=1;
		}
	}
	($nix,$nix,$nix,$gid) = getpwnam($_[0]);
	$grname=getgrgid($gid);
	if (($_[2] =~ /$grname/) && (length($grname)>0)) {
		$st_=1;
	}
	if ( "$_[1]," =~ /$_[0],/ ) {
		$st_=1;
	}
	return $st_;
}
sub print_list {
	#print all free/deny user
	#printlist(userlist, grouplist);
	$ll="";
	$ll.=sprintf("%s,",$_[0]);
	@g = split( /,/ , $_[1]);
	for ($i=0;$i<=$#g;$i++) {
		($nix,$nix,$nix,$mem)=getgrnam($g[$i]);
		$mem =~ s/ /,/g; #for all unix-compatibilty
		$ll.=sprintf("%s,",$mem);
	}
	for ($i=0;$ent_=getpwent();$i++) {
		$allu[$i]=$ent;
	}
	endpwent();
	foreach $ent(@allu) {
		($nix,$nix,$nix,$gid) = getpwnam($ent_);
		$grname=getgrgid($gid);
		if (($_[1] =~ /$grname/) && (length($grname)>0)) {
			$ll.=sprintf("%s,",$ent_);
		}
	}
	@allu=();
	while ($ll =~ /,,/) {
		$ll =~ s/,,/,/g;
	}
	@la=split(/,/,$ll);
	#printf("%s nem=%d",$ll,$#la);
	@lb=sort(@la);
	@lc=();
	$comp_="#####~";
	$ll="";
	for ($i=0;$i<=$#lb;$i++) {
		if ($comp_ eq $lb[$i]) {
			next;
		}
		$comp_=$lb[$i];
		if (length($ll)>0) {
			$ll.=",";
		}
		$ll.=$lb[$i];
	}
	return $ll;
}
sub check_deny {
	return check_list($_[0],$denyuser,$denygroup);
}
sub check_free {
	return check_list($_[0],$freeuser,$freegroup);
}
sub touch_user_file {
	#usage touch_user_file(user);
	#creates user file if one does not exists
	#and set correct permission of database file
	if (! -e "$accdir/$_[0].acc") {
		umask "007";
		system "touch $accdir/$_[0].acc";
		system "chgrp $lpgroup $accdir/$_[0].acc";
	}
	return 0;
}
sub readcontingentperiod {
	#read time periods in contingent file, that is the firts part of file
	#subfunction of readcontigent
	if (! -e "$accdir/contingent") {
		return 0;
	}
	open IDS, "$accdir/contingent";
	for ($i=0;$u=<IDS>;) {
		$u =~ s/\n//g; #delete newline codes
		$u =~ s/#.*//; #ignore #remarks
		$u =~ s/ //g; #delete space characters
		if (length($u)<1) { next; }
		if ($u =~ /\[list\]/) {	last; } #abort if the end of 1st part is reached
		#parse string and add stack of free periods
		($plan[$i]{plan},$plan[$i]{time0},$plan[$i]{time1})= split /:/, $u;
		$plan[$i]{time0} = substr( $plan[$i]{time0}."000000",0,16);
		$plan[$i]{time1} = substr( $plan[$i]{time1}."000000",0,16);
		$i++;
		#---
	}
	close IDS;
}
sub readcontingent {
	#serach for printer contingents
	#parse current time
	($s,$m,$h,$d,$mn,$y,$nix,$nix,$nix)=gmtime(time);
	$mn++; #special format of unix time struct
	$y+=1900; #special format of unix time struct
	$dat= sprintf ("%04s%02s%02s%02s%02s%02s", $y, $mn, $d, $h, $m, $s);

	$free_=0;
	readcontingentperiod();
	$part=0;
	$used=0;
	open IDS, "$accdir/contingent";
	while ($u=<IDS>) {
		$u =~ s/\n//g;
		$u =~ s/#.*//;
		$u =~ s/ //g;
		if (length($u)<1) {
			next;
		}
		#read while the beginning of second part is not yet reached
		if ($u =~ /\[list\]/) {
			$part=1;
			next;
		}
		if (!$part) {
			next;
		}
		#---
		($u,$p,$s)=split /:/, $u;
		if ("#$u#" !~ /#$_[0]#/) {
			next;
		}
		#convert plan-label to plan-id  f($p) --> $nr
		$nr=-1;
		for ($i=0;$i<=$#plan;$i++) {
			if ( ($plan[$i]{plan} =~ /$p/) && (length($plan[$i]{plan})==length($p)) ) {
				$nr=$i;
				last;
			}
		}
		if ($nr<0) {
			next;
		}
		if (($plan[$nr]{time0}>$dat) || ($plan[$nr]{time1}<$dat)) {
			next;
		}
		#plus free pages
		$free_ += $s;
		#minus for already free printed
		open HAND, "$accdir/$_[0].acc";
		for ($lnr=0;$l=<HAND>; $lnr++) {
			$l =~ s/\n//g;
			($d,$u,$s,$f)=split /:/, $l;
			if ($f !~ /F/) {
				next;
			}
			if (($plan[$nr]{time0}>$d) || ($plan[$nr]{time1}<$d)) {
				next;
			}
			if ($used[$lnr]==1) {
				next;
			}
			$used[ $lnr ]=1;
			$free_ -= $s;
		}
		close HAND;
	}
	close IDS;
	if ($free_<0) {
		$free_=0;
	}
	return $free_;
}
sub get_val {
	#usage: get_val(printer);
	#get the value of money for one page of 'printer'
	for ($x=0;$x<=$#printerlist;$x++) {
		if ($printerlist[$x] eq $_[0]) {
			return $val[$x];
		}
	}
	return $val[0];
}
sub calc_money {
	#usage: calc_money(user);
	#show the total money account of user
	$sum=0;
	open HAND, "$accdir/$_[0].acc";
	while ($u=<HAND>) {
		$u =~ s/\n//g;
		($datum,$user,$page,$flag,$pri,$trans)= split(/:/, $u,6);
		if ($flag =~ /[c]/) {
			$sum+=get_val($pri)*$page; #printf("correc %f\n",get_val($pri)*$page);
		}
		if ($flag =~ /[b]/) {
			$sum-=get_val($pri)*$page; #printf("burden %f\n",get_val($pri)*$page);
		}
		if ($flag =~ /[+]/) {
			$sum+=$trans; #printf("+ $trans\n");
		}
		if ($flag =~ /[\-]/) {
			$sum-=get_val($pri)*$page; #printf("- %f pri=|%s| val=%f\n",get_val($pri)*$page,$pri,get_val($pri));
		}
		if ($flag =~ /[r]/) {
			$sum-=$trans; #printf("ret $trans\n");
		}
	}
	close HAND;
	if (abs($sum)<0.00001) {
		$sum=0;#damit kein -0.00000 auftritt
	}
	return $sum;
}
sub get_status {
	#usage: get_status(user)
	#display the status of 'user'
	#return values: yes, grey, no
	$label="";
	$money= calc_money($_[0]);
	if ($money >= $greylimit) {
		#more than greylimit for fund
		$label="yes";
	} else {
		if ($money >= $debtlimit) {
			#fund between greylimit and deplimit
			$label="grey";
		} else {
			#too many debts
			$label="no";
		}
	}
	return $label;
}
