#! /usr/bin/perl
#
# lpim - List Printer Account Improved
#
require "lp_inc";

#print out usage for script
sub usage {
	print "usage $0 user value\n";
	print "user\tusername\n";
	print "value\tpay back the sum value to user\n";
	print "\tformat: x.xx,  must be valid positive value\n";
}
readconf();
#---
# check for parameters
if ( $#ARGV < 1 ) {
	usage;
        exit;
}
$user = $ARGV[0];
$back = $ARGV[1];
#---
# greater than 0 and a natural multiply of val
if ( $back<=0)  {
	usage;
	exit;
}
#---
# does user exist ?
($uname,$nix)=getpwnam($user);
if (!$uname) {
	printf("No such user '$user'\n");
	exit;
}
#---
#calculate sum of money to pay back
$money = calc_money($user);
if ($money<=0) {
	print "$label_acc $money $currency of user '$user' is too less\n";
	exit;
}
if ( ($back == 0) || ($back>$money ) ) {
	$back=$money;
}

#does file exists?
touch_user_file($user);
#---
#parse current time
($s,$m,$h,$d,$mn,$y,$wd,$yd,$i)=gmtime(time);
$mn++; #special format of unix time struct
$y+=1900; #special format of unix time struct
$dat= sprintf ("%04s%02s%02s%02s%02s%02s", $y, $mn, $d, $h, $m, $s);
#---
$s = sprintf ("%s:%s:%d:%s:%s:%.2f\n", $dat, $user, $pages,"r","",$back);
open HAND, ">>$accdir/$user.acc";
print HAND $s;
close HAND;
