#! /usr/bin/perl
#
# lpim - List Printer Account Improved
#
require "lp_inc";
#print out usage of program
sub usage {
	print "usage $0 [user]\n";
}
readconf();
#---
# check parameter count
if ( $#ARGV < 0 ) {
	usage;
	exit;
}
$user= $ARGV[0];
$opt=$ARGV[1];
#---
# does user exist ?
($uname,$nix)=getpwnam($user);
if (!$uname) {
	usage;
	printf("No such user '$uname'\n");
	exit;
}
#---
#exit if there is not yet any account file
if ( ! -e "$accdir/$user.acc" ) {
	exit;
}
#---
# calculate accout
$money=calc_money($user);
#---
#check for fund / debt
if ( ($opt !~ /\-r/) && (abs($money)>0) ) {
	printf "user '%s' has still %6.2f %s\n",$user,$money,$currency;
	print "execute '$0 user -r' to remove user entry ignoring fund or debt\n";
	exit;
}
#---
#check for any still existing trash to avoid double file names
$trash=$accdir."/".$user;
while ( -e "$trash.ecc" ) {
	$trash.="_";
}
$trash .= ".ecc";
system "mv $accdir/$user.acc $trash";
#---
