#! /usr/bin/perl
#
# lpim - List Printer Account Improved
#
require "lp_inc";

use Env qw( USER SUDO_USER );

#comfortable output of username
sub fstring {
	$s=$_[0];
	while (length $s < $_[1]) {
		$s .= " ";
	}
	$s=substr($s,0,$_[1]);
	return $s;
}
readconf();
sub calcuser {
	$username=$_[0];
	#begin new calculation
	$gained=0;
	$printed=0;
	$payed=0;
	$corrected=0;
	$free=0;
	$sum=0;
	$deny_fixed=0;
	$free_fixed=0;
	if (-e "$accdir/$username.acc" ) {
		$sum=calc_money($username);
		open HAND, "$accdir/$username.acc";
		while ($u=<HAND>) {
			($datum,$user,$page,$flag,$printer,$trans)= split( /:/, $u,6);
			if ( ($time0>$datum) || ($time1<$datum) ) {
				#exclude entries out off definded time period
				next;
			}
			if ($flag =~ /[+]/) {
				$payed+=$page;
			}
			if ($flag =~ /[\-]/) {
				$gained+=$page;
			}
			if ($flag =~ /[c]/) {
				$corrected+=$page;
			}
			if ($flag =~ /[r]/) {
				$payed-=$page;
			}
			if ($flag =~ /[f|\-]/) {
				$printed+=$page;
			}
			if ($flag =~ /[f]/) {
				$free+=$page;
			}
		}
  		close HAND;
	}
	# check for freeperiod or denied users
	@label_comment=();
	if (check_free($username)) {
		$free_fixed=1;
		push(@label_comment,$label_freestatus);
	}
	$free_limit=readcontingent($username);
	#---
	#is user denied?
	if (check_deny($username)) {
		$deny_fixed=1;
		push(@label_comment,$label_denystatus);
	}
	if (get_status($username) eq "no") {
		push(@label_comment,$label_maxdebt);
	}
	#---
	#full name
	($nix,$nix,$nix,$nix,$nix,$nix,$fullname) = getpwnam($username);
	#---
	# statistic output
	$money = $sum;
	#convert -+ range of money to debt and fund range
	if ($money<0) {
		$label=$label_debt;
	} else {
		$label=$label_fund;
	}
	if ($ext) {
		$out="";
	        #output
		$o= sprintf("%2d.%2d. %4d - %2d.%2d. %4d\n",$start_d, $start_mn, $start_y,$end_d, $end_mn, $end_y);
		$tem=$lp_stat_tem;
		$tem=~ s/\$timeperiod/$o/g;
		$tem=~ s/\$fullname/$fullname/g;
		$tem=~ s/\$username/$username/g;
		$o=sprintf("%d",$printed);
		$tem=~ s/\$printed/$o/g;
		$o=sprintf("%d",$free);
		$tem=~ s/\$freeprinted/$o/g;
		$o=sprintf("%d",$free_limit);
		$tem=~ s/\$contingents/$o/g;
		$o=sprintf("%.2f",$money);
		$tem=~ s/\$money/$o/g;
		$tem=~ s/\$status/$label/g;
		$out .= $tem;
		$out .= "\n";

		foreach $a_(@label_comment) {
			$out .= sprintf("%30s  %s\n","",$a_);
		}
	} else {
		$out = sprintf( "%s %10.2f %8d %8d %10.2f %10d",fstring ($username,15),$money, $printed, $corrected+$free,$payed*$val,$free_limit);
  		if ($free_fixed>0) {
			$out .= "f";
		}
  		if ($deny_fixed>0) {
			$out .= "d";
		}
		$out .= "\n";
	}
	#---
	#check whether program should inform all users
	if ($inform) {
		if ($printed+$payed>0) {
			#only if there where event else nothing
			$mailtext = sprintf ("From: %s\nSubject: %s\n\n%s\n",$lpadminmail,$label_inform,$head.$out);
			open IDS, "|/usr/sbin/sendmail $username";
			print IDS $mailtext;
			close IDS;
		}
	} else {
		print $out;
	}
	#---
	return 0;
}
#---

#set default time parameter
($q,$q,$q,$start_d,$start_mn,$start_y,$q,$q,$q)=gmtime(time()-($period * 24 * 60 * 60));
$start_mn++;
$start_y+=1900;
($q,$q,$q,$end_d,$end_mn,$end_y,$q,$q,$q)=gmtime(time());
$end_mn++;
$end_y+=1900;
#---
#set defaults
$inform=0;
$ext=1;
$all=0;
#---
#pars argv
for ($i=0; $i<=$#ARGV; $i++) {
	if ($ARGV[$i] =~ /\-s/) {
		if ($ARGV[$i+1] =~ /\./) {
			($start_d,$start_mn,$start_y)=split /\./, $ARGV[$i+1];
		}
		if ($ARGV[$i+1] =~ /\//) {
			($start_d,$start_mn,$start_y)=split /\//, $ARGV[$i+1];
		}
		if ($ARGV[$i+1] =~ /\-/) {
			($start_y,$start_mn,$start_d)=split /\-/, $ARGV[$i+1];
		}
		$i++;
		next;
	}
	if ($ARGV[$i] =~ /\-e/) {
		if ($ARGV[$i+1] =~ /\./) {
			($end_d,$end_mn,$end_y)=split /\./, $ARGV[$i+1];
		}
		if ($ARGV[$i+1] =~ /\//) {
			($end_d,$end_mn,$end_y)=split /\//, $ARGV[$i+1];
		}
		if ($ARGV[$i+1] =~ /\-/) {
			($end_y,$end_mn,$end_d)=split /\-/, $ARGV[$i+1];
		}
		$i++;
		next;
	}
	if ($ARGV[$i] =~ /\-mail/) {
		$inform=1;
		$all=1;
		next;
	}
	if ($ARGV[$i] =~ /\-a/) {
		$all=1;
		$ext=0;
		next;
	}
	$USER=$ARGV[$i];
}

#check super user execution
#in the case if lp_stat is executed from sudo lp_stat
#to avoid forbidden access to database
if (defined($SUDO_USER)) {
	$all=0; $inform=0;
	$USER=$SUDO_USER;
}
#---
#make time string
$time0 = sprintf "%04d%02d%02d000000", $start_y, $start_mn, $start_d;
$time1 = sprintf "%04d%02d%02d235959", $end_y, $end_mn, $end_d;
#---
#make header
if (!$ext) {
	printf( "%s %2d.%2d. %4d - %2d.%2d. %4d\n",fstring ($label_intervall,15),$start_d, $start_mn, $start_y,$end_d, $end_mn, $end_y);
	printf( "%s %10s %8s %8s %10s %10s\n", fstring ($label_user,15), "Money","printed" , "free pr.", "payed", "conting.");
}
#---
#read template
$lp_stat_tem="";
open H, "$accdir/lp_stat.tem";
while ($l=<H>) {
	$l =~ s/\n//g;
	$p=index($l," ");
	$rest=substr($l,$p+1);

	if ($l =~ /^label_freestatus/ ) {
		$label_freestatus=$rest; next;
	}
	if ($l =~ /^label_denystatus/ ) {
		$label_denystatus=$rest; next;
	}
	if ($l =~ /^label_deny/ ) {
		$label_deny=$rest; next;
	}
	if ($l =~ /^label_maxdebt/ ) {
		$label_maxdebt=$rest; next;
	}
	if ($l =~ /^label_debt/ ) {
		$label_debt=$rest; next;
	}
	if ($l =~ /^label_fund/ ) {
		$label_fund=$rest; next;
	}
	if ($l =~ /^#/) { next; }
	$l =~ s/#.*//;

	$lp_stat_tem.="$l\n";
}
close H;
#----
#switch between modus 'all user' and 'one user'
if ( $all ) {
	#look for account files and copy entries to dirlist
	$ent="";
	for ($i=0;$ent=getpwent();$i++) {
		$fulllist[$i]=$ent;
	}
	for ($_i_=0;$_i_<=$#fulllist;$_i_++) {
		calcuser($fulllist[$_i_]);
	}
	endpwent();
} else {
	# does user exist ?
	($uname,$p)=getpwnam($USER);
	if (!$uname) {
		printf("No such user '$USER'\n");
		exit;
	}
	calcuser($uname);
	#list only exists of given username
}
